clear;clc
% Plot the mainstream queues
%% Plot the FT first
load('FT_Queues.mat')
Queue=[w_o1_1;w_o1_2;w_o1_3;w_o1_4;w_o1_5;w_o1_6;w_o1_7;w_o1_8;w_o1_9;w_o1_10;w_o1_11;w_o1_12;...
    w_o1_13;w_o1_14;w_o1_15;w_o1_16;w_o1_17;w_o1_18;w_o1_19;w_o1_20];
y=Queue;
N = size(y,1);                                      % Number of ‘Experiments’ In Data Set
yMean = mean(y);                                    % Mean Of All Experiments At Each Value Of ‘x’
ySEM = std(y)/sqrt(N);                              % Compute ‘Standard Error Of The Mean’ Of All Experiments At Each Value Of ‘x’
CI95 = tinv([0.025 0.975], N-1);                    % Calculate 95% Probability Intervals Of t-Distribution
yCI95 = bsxfun(@times, ySEM, CI95(:));              % Calculate 95% Confidence Intervals Of All Experiments At Each Value Of ‘x’
y_b=yCI95+yMean;
y_conf=[[y_b(1,:)] [y_b(2,end:-1:1)]];
x_conf=[[1/360:1/360:2.5], [2.5:-1/360:1/360]];
figure
p = fill(x_conf,y_conf,'blue');
p.FaceColor = [0.5 0.5 1];
p.FaceAlpha = 0.5;
p.EdgeColor = 'none';
hold on
plot(1/360:1/360:2.5, yMean, '-b', 'linewidth', 0.5)
%% Plot DRL
clear
load('DRL_Queues.mat')
Queue=[w_o1_1;w_o1_2;w_o1_3;w_o1_4;w_o1_5;w_o1_6;w_o1_7;w_o1_8;w_o1_9;w_o1_10;w_o1_11;w_o1_12;...
    w_o1_13;w_o1_14;w_o1_15;w_o1_16;w_o1_17;w_o1_18;w_o1_19;w_o1_20];
y=Queue;
N = size(y,1);                                      % Number of ‘Experiments’ In Data Set
yMean = mean(y);                                    % Mean Of All Experiments At Each Value Of ‘x’
ySEM = std(y)/sqrt(N);                              % Compute ‘Standard Error Of The Mean’ Of All Experiments At Each Value Of ‘x’
CI95 = tinv([0.025 0.975], N-1);                    % Calculate 95% Probability Intervals Of t-Distribution
yCI95 = bsxfun(@times, ySEM, CI95(:));              % Calculate 95% Confidence Intervals Of All Experiments At Each Value Of ‘x’
y_b=yCI95+yMean;
y_conf=[[y_b(1,:)] [y_b(2,end:-1:1)]];
x_conf=[[1/360:1/360:2.5], [2.5:-1/360:1/360]];
hold on
p = fill(x_conf,y_conf,'green');
p.FaceColor = [0.4660 0.6740 0.1880];
p.FaceAlpha = 0.3;
p.EdgeColor = 'none';
hold on
plot(1/360:1/360:2.5, yMean,'Color',[0.4660 0.6740 0.1880], 'linewidth', 1.0)
%% Plot MPC
clear
load('MPC_Queues.mat')
Queue=[w_o1_p_1;w_o1_p_2;w_o1_p_3;w_o1_p_4;w_o1_p_5;w_o1_p_6;w_o1_p_7;w_o1_p_8;w_o1_p_9;w_o1_p_10;w_o1_p_11;w_o1_p_12;...
    w_o1_p_13;w_o1_p_14;w_o1_p_15;w_o1_p_16;w_o1_p_17;w_o1_p_18;w_o1_p_19;w_o1_p_20];
y=Queue;
N = size(y,1);                                      % Number of ‘Experiments’ In Data Set
yMean = mean(y);                                    % Mean Of All Experiments At Each Value Of ‘x’
ySEM = std(y)/sqrt(N);                              % Compute ‘Standard Error Of The Mean’ Of All Experiments At Each Value Of ‘x’
CI95 = tinv([0.025 0.975], N-1);                    % Calculate 95% Probability Intervals Of t-Distribution
yCI95 = bsxfun(@times, ySEM, CI95(:));              % Calculate 95% Confidence Intervals Of All Experiments At Each Value Of ‘x’
y_b=yCI95+yMean;
y_conf=[[y_b(1,:)] [y_b(2,end:-1:1)]];
x_conf=[[1/360:1/360:2.5], [2.5:-1/360:1/360]];
hold on
p = fill(x_conf,y_conf,'green');
p.FaceColor = [0.9290 0.6940 0.1250];
p.FaceAlpha = 0.3;
p.EdgeColor = 'none';
hold on
plot(1/360:1/360:2.5, yMean,'Color',[0.9290 0.6940 0.1250], 'linewidth', 1.0)
%% Plot MPC-DRL
clear
load('MPC_DRL_Queues.mat')
Queue=[w_o1_1;w_o1_2;w_o1_3;w_o1_4;w_o1_5;w_o1_6;w_o1_7;w_o1_8;w_o1_9;w_o1_10;w_o1_11;w_o1_12;...
    w_o1_13;w_o1_14;w_o1_15;w_o1_16;w_o1_17;w_o1_18;w_o1_19;w_o1_20];
y=Queue;
N = size(y,1);                                      % Number of ‘Experiments’ In Data Set
yMean = mean(y);                                    % Mean Of All Experiments At Each Value Of ‘x’
ySEM = std(y)/sqrt(N);                              % Compute ‘Standard Error Of The Mean’ Of All Experiments At Each Value Of ‘x’
CI95 = tinv([0.025 0.975], N-1);                    % Calculate 95% Probability Intervals Of t-Distribution
yCI95 = bsxfun(@times, ySEM, CI95(:));              % Calculate 95% Confidence Intervals Of All Experiments At Each Value Of ‘x’
y_b=yCI95+yMean;
y_conf=[[y_b(1,:)] [y_b(2,end:-1:1)]];
x_conf=[[1/360:1/360:2.5], [2.5:-1/360:1/360]];
hold on
p = fill(x_conf,y_conf,'red');
p.FaceColor = [1 0.5 0.5];
p.FaceAlpha = 0.7;
p.EdgeColor = 'none';
hold on
plot(1/360:1/360:2.5, yMean,'-r', 'linewidth', 1.0)

yline(200, '--', 'Constraint', 'linewidth', 1.0)
% xlim([0.5 2])
legend('','No control','','DRL with 10-step TD','','MPC','','MPC-DRL with 10-step TD');
xlabel('Simulation time [h]');
ylabel('Queue on the mainstream')

