clear; clc
% Plot the total number of vehicles on the network
%% Plot FT first: blue
load('FT_TTS.mat')
TTS=[TTS_1;TTS_2;TTS_3;TTS_4;TTS_5;TTS_6;TTS_7;TTS_8;TTS_9;TTS_10;TTS_11;TTS_12;TTS_13;TTS_14;TTS_15;TTS_16;TTS_17;TTS_18;TTS_19;TTS_20];
TV=TTS*360;
y=TV;
N = size(y,1);                                      % Number of ‘Experiments’ In Data Set
yMean = mean(y);                                    % Mean Of All Experiments At Each Value Of ‘x’
ySEM = std(y)/sqrt(N);                              % Compute ‘Standard Error Of The Mean’ Of All Experiments At Each Value Of ‘x’
CI95 = tinv([0.025 0.975], N-1);                    % Calculate 95% Probability Intervals Of t-Distribution
yCI95 = bsxfun(@times, ySEM, CI95(:));              % Calculate 95% Confidence Intervals Of All Experiments At Each Value Of ‘x’
y_b=yCI95+yMean;
y_conf=[[y_b(1,:)] [y_b(2,end:-1:1)]];
x_conf=[[1/360:1/360:2.5], [2.5:-1/360:1/360]];
figure
p = fill(x_conf,y_conf,'blue');
p.FaceColor = [0.5 0.5 1];
p.FaceAlpha = 0.5;
p.EdgeColor = 'none';
hold on
plot(1/360:1/360:2.5, yMean, '-b', 'linewidth', 0.5)

%% Plot DRL: green
clear
load('DRL_TTS.mat')
TTS=[TTS_1;TTS_2;TTS_3;TTS_4;TTS_5;TTS_6;TTS_7;TTS_8;TTS_9;TTS_10;TTS_11;TTS_12;TTS_13;TTS_14;TTS_15;TTS_16;TTS_17;TTS_18;TTS_19;TTS_20];
TV=TTS*360;
y=TV;
N = size(y,1);                                      % Number of ‘Experiments’ In Data Set
yMean = mean(y);                                    % Mean Of All Experiments At Each Value Of ‘x’
ySEM = std(y)/sqrt(N);                              % Compute ‘Standard Error Of The Mean’ Of All Experiments At Each Value Of ‘x’
CI95 = tinv([0.025 0.975], N-1);                    % Calculate 95% Probability Intervals Of t-Distribution
yCI95 = bsxfun(@times, ySEM, CI95(:));              % Calculate 95% Confidence Intervals Of All Experiments At Each Value Of ‘x’
y_b=yCI95+yMean;
y_conf=[[y_b(1,:)] [y_b(2,end:-1:1)]];
x_conf=[[1/360:1/360:2.5], [2.5:-1/360:1/360]];
hold on
p = fill(x_conf,y_conf,'green');
p.FaceColor = [0.4660 0.6740 0.1880];
p.FaceAlpha = 0.3;
p.EdgeColor = 'none';
hold on
plot(1/360:1/360:2.5, yMean,'Color',[0.4660 0.6740 0.1880], 'linewidth', 1.0)

%% Plot MPC: yellow
clear
load('MPC_TTS.mat')
TTS=[TTS_p_1;TTS_p_2;TTS_p_3;TTS_p_4;TTS_p_5;TTS_p_6;TTS_p_7;TTS_p_8;TTS_p_9;TTS_p_10;TTS_p_11;TTS_p_12;TTS_p_13;TTS_p_14;TTS_p_15;TTS_p_16;TTS_p_17;TTS_p_18;TTS_p_19;TTS_p_20];
TV=TTS*360;
y=TV;
N = size(y,1);                                      % Number of ‘Experiments’ In Data Set
yMean = mean(y);                                    % Mean Of All Experiments At Each Value Of ‘x’
ySEM = std(y)/sqrt(N);                              % Compute ‘Standard Error Of The Mean’ Of All Experiments At Each Value Of ‘x’
CI95 = tinv([0.025 0.975], N-1);                    % Calculate 95% Probability Intervals Of t-Distribution
yCI95 = bsxfun(@times, ySEM, CI95(:));              % Calculate 95% Confidence Intervals Of All Experiments At Each Value Of ‘x’
y_b=yCI95+yMean;
y_conf=[[y_b(1,:)] [y_b(2,end:-1:1)]];
x_conf=[[1/360:1/360:2.5], [2.5:-1/360:1/360]];
hold on
p = fill(x_conf,y_conf,'green');
p.FaceColor = [0.9290 0.6940 0.1250];
p.FaceAlpha = 0.3;
p.EdgeColor = 'none';
hold on
plot(1/360:1/360:2.5, yMean,'Color',[0.9290 0.6940 0.1250], 'linewidth', 1.0)

%% Plot MPC-DRL: red
clear
load('MPC_DRL_TTS_10steps.mat')
TTS=[TTS_1;TTS_2;TTS_3;TTS_4;TTS_5;TTS_6;TTS_7;TTS_8;TTS_9;TTS_10;TTS_11;TTS_12;TTS_13;TTS_14;TTS_15;TTS_16;TTS_17;TTS_18;TTS_19;TTS_20];
TV=TTS*360;
y=TV;
N = size(y,1);                                      % Number of ‘Experiments’ In Data Set
yMean = mean(y);                                    % Mean Of All Experiments At Each Value Of ‘x’
ySEM = std(y)/sqrt(N);                              % Compute ‘Standard Error Of The Mean’ Of All Experiments At Each Value Of ‘x’
CI95 = tinv([0.025 0.975], N-1);                    % Calculate 95% Probability Intervals Of t-Distribution
yCI95 = bsxfun(@times, ySEM, CI95(:));              % Calculate 95% Confidence Intervals Of All Experiments At Each Value Of ‘x’
y_b=yCI95+yMean;
y_conf=[[y_b(1,:)] [y_b(2,end:-1:1)]];
x_conf=[[1/360:1/360:2.5], [2.5:-1/360:1/360]];
hold on
p = fill(x_conf,y_conf,'red');
p.FaceColor = [1 0.5 0.5];
p.FaceAlpha = 0.7;
p.EdgeColor = 'none';
hold on
plot(1/360:1/360:2.5, yMean,'-r', 'linewidth', 1.0)

legend('','No control','','DRL with 10-step TD','','MPC','','MPC-DRL with 10-step TD');
xlabel('Simulation time [h]');
ylabel('Total number of vehicles')

% TTS=[sum(TTS_1) sum(TTS_2) sum(TTS_3) sum(TTS_4) sum(TTS_5) sum(TTS_6) sum(TTS_7) sum(TTS_8) ...
%     sum(TTS_9) sum(TTS_10) sum(TTS_11) sum(TTS_12) sum(TTS_13) sum(TTS_14) sum(TTS_15) sum(TTS_16)...
%     sum(TTS_17) sum(TTS_18) sum(TTS_19) sum(TTS_20)];
% 
% 
% TTS=[sum(TTS_p_1) sum(TTS_p_2) sum(TTS_p_3) sum(TTS_p_4) sum(TTS_p_5) sum(TTS_p_6) sum(TTS_p_7) sum(TTS_p_8) ...
%     sum(TTS_p_9) sum(TTS_p_10) sum(TTS_p_11) sum(TTS_p_12) sum(TTS_p_13) sum(TTS_p_14) sum(TTS_p_15) sum(TTS_p_16)...
%     sum(TTS_p_17) sum(TTS_p_18) sum(TTS_p_19) sum(TTS_p_20)];