clear;clc

%% plot the reward of DRL 1-step: yellow
clear
load('DRL_1step_rewards.mat')
y=[reward1';reward2';reward3';reward4';reward5';reward6';reward7';reward8';reward9';reward10'];
N = size(y,1);                                      % Number of ‘Experiments’ In Data Set
yMean = mean(y);                                    % Mean Of All Experiments At Each Value Of ‘x’
ySEM = std(y)/sqrt(N);                              % Compute ‘Standard Error Of The Mean’ Of All Experiments At Each Value Of ‘x’
CI95 = tinv([0.025 0.975], N-1);                    % Calculate 95% Probability Intervals Of t-Distribution
yCI95 = bsxfun(@times, ySEM, CI95(:));              % Calculate 95% Confidence Intervals Of All Experiments At Each Value Of ‘x’
y_b=yCI95+yMean;
y_conf=[[y_b(1,:)] [y_b(2,end:-1:1)]];
x_conf=[[1:4000], [4000:-1:1]];
figure
p = fill(x_conf,y_conf,'green');
p.FaceColor = [0.9290 0.6940 0.1250];
p.FaceAlpha = 0.3;
p.EdgeColor = 'none';
hold on
plot(1:4000, yMean, 'Color',[0.9290 0.6940 0.1250], 'linewidth', 0.5)
%% plot the reward of DRL 10-steps: blue
clear
load('DRL_Rewards_10Steps.mat')
y=[reward1';reward2';reward3';reward4';reward5';reward6';reward7';reward8';reward9';reward10'];
N = size(y,1);                                      % Number of ‘Experiments’ In Data Set
yMean = mean(y);                                    % Mean Of All Experiments At Each Value Of ‘x’
ySEM = std(y)/sqrt(N);                              % Compute ‘Standard Error Of The Mean’ Of All Experiments At Each Value Of ‘x’
CI95 = tinv([0.025 0.975], N-1);                    % Calculate 95% Probability Intervals Of t-Distribution
yCI95 = bsxfun(@times, ySEM, CI95(:));              % Calculate 95% Confidence Intervals Of All Experiments At Each Value Of ‘x’
y_b=yCI95+yMean;
y_conf=[[y_b(1,:)] [y_b(2,end:-1:1)]];
x_conf=[[1:4000], [4000:-1:1]];
hold on
p = fill(x_conf,y_conf,'blue');
p.FaceColor = [0.5 0.5 1];
p.FaceAlpha = 0.3;
p.EdgeColor = 'none';
hold on
plot(1:4000, yMean, '-b', 'linewidth', 0.5)

%% plot the reward of MPC-DRL 1-step: green
clear
load('MPC_RL_Rewards_1Steps.mat')
y=[reward1';reward2';reward3';reward4';reward5';reward6';reward7';reward8';reward9';reward10'];
N = size(y,1);                                      % Number of ‘Experiments’ In Data Set
yMean = mean(y);                                    % Mean Of All Experiments At Each Value Of ‘x’
ySEM = std(y)/sqrt(N);                              % Compute ‘Standard Error Of The Mean’ Of All Experiments At Each Value Of ‘x’
CI95 = tinv([0.025 0.975], N-1);                    % Calculate 95% Probability Intervals Of t-Distribution
yCI95 = bsxfun(@times, ySEM, CI95(:));              % Calculate 95% Confidence Intervals Of All Experiments At Each Value Of ‘x’
y_b=yCI95+yMean;
y_conf=[[y_b(1,:)] [y_b(2,end:-1:1)]];
x_conf=[[1:4000], [4000:-1:1]];
hold on
p = fill(x_conf,y_conf,'green');
p.FaceColor = [0.4660 0.6740 0.1880];
p.FaceAlpha = 0.3;
p.EdgeColor = 'none';
hold on
plot(1:4000, yMean,'Color',[0.4660 0.6740 0.1880], 'linewidth', 1.0)

%% plot the reward of MPC-DRL 10-steps: red
clear
load('MPC_RL_Rewards_10Steps.mat')
y=[reward1';reward2';reward3';reward4';reward5';reward6';reward7';reward8';reward9';reward10'];
N = size(y,1);                                      % Number of ‘Experiments’ In Data Set
yMean = mean(y);                                    % Mean Of All Experiments At Each Value Of ‘x’
ySEM = std(y)/sqrt(N);                              % Compute ‘Standard Error Of The Mean’ Of All Experiments At Each Value Of ‘x’
CI95 = tinv([0.025 0.975], N-1);                    % Calculate 95% Probability Intervals Of t-Distribution
yCI95 = bsxfun(@times, ySEM, CI95(:));              % Calculate 95% Confidence Intervals Of All Experiments At Each Value Of ‘x’
y_b=yCI95+yMean;
y_conf=[[y_b(1,:)] [y_b(2,end:-1:1)]];
x_conf=[[1:4000], [4000:-1:1]];
hold on
p = fill(x_conf,y_conf,'red');
p.FaceColor = [1 0.5 0.5];
p.FaceAlpha = 0.7;
p.EdgeColor = 'none';
hold on
plot(1:4000, yMean, '-r', 'linewidth', 1.0)

ylim([-2600 -1100])
xlabel('Episode')
ylabel('Reward')
legend('','DRL','','DRL 10-step TD','','MPC-DRL','','MPC-DRL 10-step TD')